<?php // Modified for WPH (Translated)
define('WP_INSTALLING', true);

require_once('../wp-includes/compat.php');
require_once('../wp-includes/functions.php');

if (!file_exists('../wp-config-sample.php'))
	wp_die('Sorry, I need a wp-config-sample.php file to work from. Please re-upload this file from your WordPress installation.');

$configFile = file('../wp-config-sample.php');

if ( !is_writable('../')) 
	wp_die("Sorry, I can't write to the directory. You'll have to either change the permissions on your WordPress directory or create your wp-config.php manually.");

// Check if wp-config.php has been created
if (file_exists('../wp-config.php'))
	wp_die("<p>הקובץ '<code>wp-config.php</code>' קיים כבר. כדי להגדיר מחדש את פרטי החיבור לבסיס הנתונים, יש למחוק אותו. אפשר לנסות <a href='install.php'>להתחיל בהתקנה</a>.</p>"); // WPH - Error message

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

function display_header(){
	header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="rtl">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>וורדפרס בעברית &rsaquo; יצירת קובץ הגדרות</title> <?php /* WPH - Hebrew title */ ?> 
<style media="screen" type="text/css">
	<!--
	html {
		background: #eee;
	}
	body {
		background: #fff;
		color: #000;
		font-family: "Times New Roman", serif;
		margin-left: 20%;
		margin-right: 20%;
		padding: .2em 2em;
	}

	h1 {
		color: #006;
		font-size: 18px;
		font-weight: lighter;
	}

	h2 {
		font-size: 16px;
	}

	p, li, dt {
		line-height: 140%;
		padding-bottom: 2px;
	}

	ul, ol {
		padding: 5px 5px 5px 20px;
	}
	#logo {
		margin-bottom: 2em;
	}
	.step a, .step input {
		font-size: 2em;
	}
	td, th {
		padding-bottom: 3.0em;
		vertical-align: top;
	}
	td input {
		font-size: 1.5em;
		direction: ltr;
		width: 10em;
		margin: 0 0.6em;
	}
	.step, th {
		text-align: left;
	}
	#footer {
		text-align: center;
		border-top: 1px solid #ccc;
		padding-top: 1em;
		font-style: italic;
	}
	-->
	</style>
</head>
<body>
<h1 id="logo"><img alt="WordPress" src="images/wordpress-logo.png" /></h1>
<?php
}//end function display_header();

switch($step) {
	case 0:
		display_header();
?>

<p>ברוכים הבאים לוורדפרס. לפני ההתקנה, אני צריכה קצת מידע על בסיס הנתונים. כדאי לברר את זה <em>לפני</em> שממשיכים.</p>
<ol>
	<li>שם בסיס הנתונים</li>
	<li>שם משתמש בבסיס הנתונים</li>
	<li>הסיסמה של אותו משתמש</li>
	<li>הכתובת (host) של בסיס הנתונים</li>
	<li>קידומת לטבלאות (בשביל להפעיל כמה התקנות של וורדפרס מבסיס נתונים אחד) </li>
</ol>
<p><strong>אם אני לא אצליח ליצור את הקובץ - אין מה לדאוג. אפשר פשוט לפתוח את הקובץ  <code>wp-config-sample.php</code> בכל עורך טקסט, למלא את הנתונים לפי ההוראות, ולשמור אותו בשם <code>wp-config.php</code>. </strong></p>
<p>ברוב המקרים, מי שמארח את האתר שלך גם יתן לך את הפרטים האלה. אם עוד אין לך אותם - צריך לברר אותם, כאמור, לפני ההתקנה. אם הכל בסדר, <a href="setup-config.php?step=1">אפשר להמשיך</a>! </p>

<?php
	break;

	case 1:
		display_header();
	?>
</p>
<form method="post" action="setup-config.php?step=2">
	<p>אלו הנתונים שאני צריכה על בסיס הנתונים שלך.:</p>
	<table>
		<tr>
			<th scope="row">שם בסיס הנתונים</th>
			<td><input name="dbname" type="text" size="25" value="wordpress" /></td>
			<td>השם של בסיס הנתונים בו וורדפרס תשמור את הנתונים שלה.</td>
		</tr>
		<tr>
			<th scope="row">שם משתמש</th>
			<td><input name="uname" type="text" size="25" value="username" /></td>
			<td>שם משתמש בבסיס נתונים עם הרשאות מלאות MySQL.</td>
		</tr>
		<tr>
			<th scope="row">סיסמה</th>
			<td><input name="pwd" type="text" size="25" value="password" /></td>
			<td>הסיסמה של אותו משתמש.</td>
		</tr>
		<tr>
			<th scope="row">כתובת</th>
			<td><input name="dbhost" type="text" size="25" value="localhost" /></td>
			<td>הכתובת של בסיס הנתונים. ב-99% מהמקרים לא צריך לשנות את זה - אבל לפעמים כן (עם Dreamhost, למשל).</td>
		</tr>
		<tr>
			<th scope="row">קידומת לטבלאות</th>
			<td><input name="prefix" type="text" id="prefix" value="wp_" size="25" /></td>
			<td>כדי להפעיל כמה התקנות של WP מבסיס נתונים אחד, אפשר להגדיר לכל התקנה קידומת טבלאות אחרת. לא צריך לשנות את זה אם זו ההתקנה היחידה.</td>
		</tr>
	</table>
	<h2 class="step">
	<input name="submit" type="submit" value="ליצור את הקובץ" />
	</h2>
</form>
<?php
	break;

	case 2:
	$dbname  = trim($_POST['dbname']);
	$uname   = trim($_POST['uname']);
	$passwrd = trim($_POST['pwd']);
	$dbhost  = trim($_POST['dbhost']);
	$prefix  = trim($_POST['prefix']);
	if (empty($prefix)) $prefix = 'wp_';

	// Test the db connection.
	define('DB_NAME', $dbname);
	define('DB_USER', $uname);
	define('DB_PASSWORD', $passwrd);
	define('DB_HOST', $dbhost);

	// We'll fail here if the values are no good.
	require_once('../wp-includes/wp-db.php');
	$handle = fopen('../wp-config.php', 'w');

	foreach ($configFile as $line_num => $line) {
		switch (substr($line,0,16)) {
			case "define('DB_NAME'":
				fwrite($handle, str_replace("putyourdbnamehere", $dbname, $line));
				break;
			case "define('DB_USER'":
				fwrite($handle, str_replace("'usernamehere'", "'$uname'", $line));
				break;
			case "define('DB_PASSW":
				fwrite($handle, str_replace("'yourpasswordhere'", "'$passwrd'", $line));
				break;
			case "define('DB_HOST'":
				fwrite($handle, str_replace("localhost", $dbhost, $line));
				break;
			case '$table_prefix  =':
				fwrite($handle, str_replace('wp_', $prefix, $line));
				break;
			default:
				fwrite($handle, $line);
		}
	}
	fclose($handle);
	chmod('../wp-config.php', 0666);
	
	display_header();
?>
<p>זה הכל! סיימנו עם ההכנות, עכשיו אני יכולה להתחבר לבסיס הנתונים ולהתקין בו את וורדפרס. בזמנך החופשי, אפשר <a href="install.php">להתחיל בהתקנה!</a></p>
<?php
	break;
}
?>
<p id="footer"><a href="http://wph.co.il/">וורדפרס בעברית</a>,  מערכת אישית בקוד פתוח לניהול בלוגים עצמאיים</p>
	
	
</body>
</html>
