<?php

$text_direction = 'rtl';

if ( !function_exists('wp_mail') ) :

function wp_mail($to, $subject, $message, $headers = '') {
	if( $headers == '' ) {
		$headers = "MIME-Version: 1.0\n" .
			"From: wordpress@" . preg_replace('#^www\.#', '', strtolower($_SERVER['SERVER_NAME'])) . "\n" . 
			"Content-Type: text/plain; charset=\"" . get_option('blog_charset') . "\"\n";
	}

	$subject = sprintf('=?utf-8?B?%s?=', base64_encode($subject)); // WPH - Encode subject to make it readable on all mail clients, by Tom Sella
    $ha = explode("\n", $headers);
    array_walk($ha, 'arbitrary_mail_header_base64_encode'); // WPH - Encode sender/reciever to make it readable on all mail clients, by Tom Sella
    $headers = implode("\n", $ha);   
	return @mail($to, $subject, $message, $headers);
}
endif;

function arbitrary_mail_header_base64_encode(&$item, $key) // WPH - Base64 encoder, by Tom Sella
{
	$fields = array('From: ', 'CC: ');
	$lcitem = strtolower($item);
	$end = strpos($lcitem, '<');
	// $bitem = $item; // for debugging, save the item string
    foreach ($fields as $field)
	{
		if (substr_count($lcitem, strtolower($field)) > 0 && $end > 0)
		{
			$start     = strlen($field);
			preg_match ('/\"(.+)\" \<.*\>/', $item, $match);
			$to_encode = $match[1];
			$to_item   = substr($item, $end);
			$item      = sprintf('%s"=?utf-8?B?%s?=" %s', $field, base64_encode($to_encode), $to_item);
		}
	//error_log(sprintf("debug: before: %s, item: %s, start: %d, to_encode: %s, to_item: %s", $bitem, $item, $start, $to_encode, $to_item)); // for debugging, write to error_log
    }
    return $item;
}

if ( !function_exists('wp_new_user_notification') ) :

function wp_new_user_notification($user_id, $plaintext_pass = '') {
	$user = new WP_User($user_id);

	$user_login = stripslashes($user->user_login);
	$user_email = stripslashes($user->user_email);

	$message  = sprintf(__('New user registration on your blog %s:'), get_option('blogname')) . "\r\n\r\n";
	$message .= sprintf(__('Username: %s'), $user_login) . "\r\n\r\n";
	$message .= sprintf(__('E-mail: %s'), $user_email) . "\r\n";

	@wp_mail(get_option('admin_email'), sprintf(__('[%s] New User Registration'), get_option('blogname')), $message);

	if ( empty($plaintext_pass) )
		return;

	$message  = sprintf(__('Username: %s'), $user_login) . "\r\n";
	$message .= sprintf(__('Password: %s'), "\r\n" . $plaintext_pass) . "\r\n"; // WPH - Fixes directionality issued with passowrds in mails sent by wordpress, by Adam Matan and Dror Kronstein 
	$message .= get_option('siteurl') . "/wp-login.php\r\n";

	wp_mail($user_email, sprintf(__('[%s] Your username and password'), get_option('blogname')), $message);

}
endif;

/*
Plugin Name: תיקון לריווח ניקוד dj_c
Plugin URI: http://www.dontsmile.info/my-plugins/plugin-dj_c/
Description: תיקון בעית ריווח בדפדפנים מבוססי מוזילה, דוגמת פיירפוקס, כאשר הטקסט מנוקד, ומיושר לשני הצדדים. מידע נוסף ב-<a href='http://www.dontsmile.info/?p=81'>www.dontsmile.info</a>
Author: תום סלע
Version: 0.6b
Author URI: http://www.dontsmile.info
*/ 

/* dj_c.php - hebrew diacritic justification correction for mozilla and derivatives
 *           (see bug 209468 at https://bugzilla.mozilla.org/show_bug.cgi?id=209468)
 *
 * version 0.4b
 *
 * 1. include this file once in your php script , e.g. using require_once, require or include directives
 *
 * 2. whenever generating a block of hebrew text, with the possibility of containing
 *    diacritics, wrap the generating call diacritic_justification(),
 *    e.g. echo the_content() becomes echo diacritic_justification(the_content())
 *
 * copyright 2006 tom sella (i[at]dontsmile[dot]info)
 * released under gpl v2
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
*/

$do_fix = is_moz();
$djs = '<span style="text-align: right;">';
$dje = '</span>';
// match: one or more base hebrew chars, followed by one or more diacritics, followed by any number of hebrew chars including diacritics
$match_heb_with_dia = '/([\x{05D0}-\x{05F2}]+[\x{05B0}-\x{05C3}]+[\x{05B0}-\x{05F2}]*)/u';
function is_moz()
{
  $ua = strtolower($_SERVER['HTTP_USER_AGENT']);
  return (substr($ua, 0, 8) == 'mozilla/' && (!strpos($ua, 'msie') && !strpos($ua, 'opera')));
}

function diacritic_justification($data = '')
{
  global $do_fix;
  global $djs, $dje;
  global $match_heb_with_dia;
  $newdata = '';
  $intags = false;
  // this workround applies only to Mozilla based (e.g. Firefox) browsers
  if ($do_fix)
  {
    while (preg_match($match_heb_with_dia, $data, $x, PREG_OFFSET_CAPTURE))
    {
      // substring before match
      $s = substr($data, 0, $x[0][1]);
      // match data
      $w = $x[0][0];
      // check if last tag was closed
      if (strrpos($s, '>') != null)
      {
        $intags = false;
      }        
      // check if within html tags
      if ((strrpos($s, '<') >= strrpos($s, '>') && strrpos($s, '<') != null) || $intags)
      {
        $intags = true;
        // if so, do nothing
        $newdata .= $s . $w;
      }
      else
      {
        // otherwise, do something
        $newdata .= $s . $djs . $w . $dje;
      }
      // set up the next section for match
      $data = substr($data,$x[0][1] + strlen($x[0][0]));
    }
  }
  return $newdata . $data;
}
function head_banner()
{
  echo "<!--// בעיות ניקודתיות תוקנו על ידי dj_c // www.dontsmile.info // תום סלע //-->\n";
}

function title_fix()
{
  // i can't use the add_filter('the_title', ...), since the_title() is also called within
  // html tags, in a stage this script does not know the context, that would result
  // in a nested tag, breaking proper html.
  // instead, i add a stylesheet that targets the title in the header
  echo "<style type='text/css'>\n/* dj_c title diacritics fix */\nh2 { text-align: right; }\n.post h3 { text-align: right; }\n</style>\n";
}

if (function_exists('diacritic_justification'))
{
  // apply fix to the title - disabled, and for a good reason
  // 
  //add_filter('the_title', 'diacritic_justification');
  // apply fix to the content
  add_filter('the_content', 'diacritic_justification');
  // apply fix to the_excerpt
  add_filter('the_excerpt', 'diacritic_justification');
  // apply fix to comments
  add_action('comment_text', 'diacritic_justification');
  // apply header info, for stats
  add_action('wp_head', 'head_banner');
  // apply fix for title
  if (is_moz())
  {
    add_action('wp_head', 'title_fix');
  }
}

/*
Plugin Name: כיווניות תגובות
Plugin URI: http://www.dontsmile.info/my-plugins/plugin-comment_direction/
Description: יישור אוטומטי לתגובות בהתאם לכיווניות של השפה הדומיננטית בהן. בבלוגים עם עיצוב מימין לשמאל, תגובות באנגלית תיושרנה כהלכה, משמאל לימין.
Author: תום סלע
Version: 1.2
Author URI: http://www.dontsmile.info
*
* copyright 2006 tom sella (i[at]dontsmile[dot]info)
* released under gpl v2
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
*  http://www.gnu.org/licenses/gpl.html
*
*/

class comment_direction
{
  function banner()
  {
    echo "<!--// comment_direction v1.2 plug-in by Tom Sella // http://www.dontsmile.info //-->";
  }

  function domina($data = '')
  {
    $text  = $this->sanitize_text($data);
    $c_eng = $this->count_it($text, '/\w+/u');
    $c_heb = $this->count_it($text, '/[\x{05B0}-\x{05F4}\x{FB1D}-\x{FBF4}]+/u');
    $c_arb = $this->count_it($text, '/[\x{060C}-\x{06FE}\x{FB50}-\x{FEFC}]+/u');
    $dir   = ($c_eng >= ($c_heb + $c_arb)) ? 'ltr' : 'rtl';
    $data  = "<div style='direction: {$dir};'><p>" . $data . "</p></div>";
    return $data;
  }

  function sanitize_text($data = '')
  {
    $sanitized = preg_replace('/<.*?>/x', '', $data); // remove html content
    $sanitized = preg_replace('/[0-9]+/', '', $sanitized); // remove numbers content
    return $sanitized;
  }

  function count_it($data = '', $match)
  {
    $i = 0;
    while (preg_match($match, $data, $x, PREG_OFFSET_CAPTURE))
    {
      $i += strlen($x[0][0]);
      $data = substr($data,$x[0][1] + strlen($x[0][0]));
    }
    return $i;
  }
  
  function comment_direction()
  {
    add_action('wp_head', array(&$this, 'banner'));
    add_action('comment_text', array(&$this, 'domina'));
  }
}

$countit = new comment_direction();
?>
